/*
 * $Id: mwd-migprep.sql 89780 2008-10-13 06:41:33Z pca $
 *
 * Prepare to migrate a OS Deployment Manager 7.9 database into OS Deployment Manager 8.0 format.
 *
 * The aim here is to make minimal changes that will allow schema.sql
 * to succeed in creating any new objects, before mwd-migpost.sql finishes
 * reshaping some tables and dropping any unused objects.
 *
 * Copyright 2011 Flexera Software LLC
 */

IF NOT EXISTS(SELECT * FROM DatabaseConfiguration WHERE Property = 'WiDepMigrationStep')
	INSERT DatabaseConfiguration (Property, Value) VALUES ('WiDepMigrationStep', 0)
ELSE
BEGIN
	DECLARE @step int
	SELECT @step = Value FROM DatabaseConfiguration WHERE Property = 'WiDepMigrationStep'
	PRINT 'Restarting migration from step '+STR(@step + 1, 2)
END
GO

-- Setup for migpost.sql
IF EXISTS(SELECT * FROM DatabaseConfiguration WHERE Property = 'WiDepMigrationStep' AND VALUE = 0)
BEGIN
	UPDATE DatabaseConfiguration SET Value = 1000 WHERE Property = 'WiDepMigrationStep'
END
GO

